Index: /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/DIA/diawri.F90
===================================================================
--- /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/DIA/diawri.F90	(revision 10115)
+++ /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/DIA/diawri.F90	(revision 10116)
@@ -125,6 +125,6 @@
       ! Output of initial vertical scale factor
       CALL iom_put("e3t_0", e3t_0(:,:,:) )
-      CALL iom_put("e3u_0", e3t_0(:,:,:) )
-      CALL iom_put("e3v_0", e3t_0(:,:,:) )
+      CALL iom_put("e3u_0", e3u_0(:,:,:) )
+      CALL iom_put("e3v_0", e3v_0(:,:,:) )
       !
       CALL iom_put( "e3t" , e3t_n(:,:,:) )
Index: /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/DOM/domvvl.F90
===================================================================
--- /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/DOM/domvvl.F90	(revision 10115)
+++ /NEMO/branches/2018/dev_r10057_ENHANCE03_ZTILDE/src/OCE/DOM/domvvl.F90	(revision 10116)
@@ -8,4 +8,5 @@
    !!            3.3  !  2011-10  (M. Leclair) totally rewrote domvvl: vvl option includes z_star and z_tilde coordinates
    !!            3.6  !  2014-11  (P. Mathiot) add ice shelf capability
+   !!            4.0  !  2018-09  (J. Chanut) improve z_tilde robustness
    !!----------------------------------------------------------------------
 
@@ -31,4 +32,7 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE timing          ! Timing
+   USE bdy_oce         ! ocean open boundary conditions
+   USE sbcrnf          ! river runoff 
+   USE dynspg_ts, ONLY: un_adv, vn_adv
 
    IMPLICIT NONE
@@ -44,20 +48,33 @@
    LOGICAL , PUBLIC :: ln_vvl_ztilde          = .FALSE.    ! ztilde vertical coordinate
    LOGICAL , PUBLIC :: ln_vvl_layer           = .FALSE.    ! level  vertical coordinate
-   LOGICAL , PUBLIC :: ln_vvl_ztilde_as_zstar = .FALSE.    ! ztilde vertical coordinate
-   LOGICAL , PUBLIC :: ln_vvl_zstar_at_eqtor  = .FALSE.    ! ztilde vertical coordinate
-   LOGICAL , PUBLIC :: ln_vvl_kepe            = .FALSE.    ! kinetic/potential energy transfer
+   LOGICAL          :: ln_vvl_ztilde_as_zstar = .FALSE.    ! ztilde vertical coordinate
+   LOGICAL          :: ln_vvl_zstar_at_eqtor  = .FALSE.    ! ztilde vertical coordinate
+   LOGICAL          :: ln_vvl_zstar_on_shelf  = .FALSE.    ! revert to zstar on shelves
+   LOGICAL          :: ln_vvl_adv_fct         = .FALSE.    ! Centred thickness advection
+   LOGICAL          :: ln_vvl_adv_cn2         = .TRUE.     ! FCT thickness advection
+   LOGICAL          :: ln_vvl_dbg             = .FALSE.    ! debug control prints
+   LOGICAL          :: ln_vvl_ramp            = .FALSE.    ! Ramp on interfaces displacement
+   LOGICAL          :: ln_vvl_lap             = .FALSE.    ! Laplacian thickness diffusion
+   LOGICAL          :: ln_vvl_blp             = .FALSE.    ! Bilaplacian thickness diffusion 
+   LOGICAL          :: ln_vvl_regrid          = .FALSE.    ! ensure layer separation 
+   LOGICAL          :: ll_shorizd             = .FALSE.    ! Use "shelf horizon depths" 
+   LOGICAL          :: ln_vvl_kepe            = .FALSE.    ! kinetic/potential energy transfer
    !                                                       ! conservation: not used yet
-   REAL(wp)         :: rn_ahe3                             ! thickness diffusion coefficient
-   REAL(wp)         :: rn_rst_e3t                          ! ztilde to zstar restoration timescale [days]
-   REAL(wp)         :: rn_lf_cutoff                        ! cutoff frequency for low-pass filter  [days]
-   REAL(wp)         :: rn_zdef_max                         ! maximum fractional e3t deformation
-   LOGICAL , PUBLIC :: ln_vvl_dbg = .FALSE.                ! debug control prints
+   REAL(wp)         :: rn_ahe3_lap               ! thickness diffusion coefficient (Laplacian)
+   REAL(wp)         :: rn_ahe3_blp               ! thickness diffusion coefficient (Bilaplacian)
+   REAL(wp)         :: rn_rst_e3t                ! ztilde to zstar restoration timescale [days]
+   REAL(wp)         :: rn_lf_cutoff              ! cutoff frequency for low-pass filter  [days]
+   REAL(wp)         :: rn_day_ramp               ! Duration of linear ramp  [days]
+   REAL(wp)         :: hsmall=0.01_wp            ! small thickness [m]
 
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: un_td, vn_td                ! thickness diffusion transport
-   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: hdiv_lf                     ! low frequency part of hz divergence
+   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: un_lf, vn_lf, hdivn_lf      ! low frequency fluxes and divergence
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: tilde_e3t_b, tilde_e3t_n    ! baroclinic scale factors
    REAL(wp), PUBLIC, ALLOCATABLE, SAVE, DIMENSION(:,:,:) :: tilde_e3t_a, dtilde_e3t_a   ! baroclinic scale factors
-   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: frq_rst_e3t                 ! retoring period for scale factors
-   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: frq_rst_hdv                 ! retoring period for low freq. divergence
+   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: tildemask                   ! mask tilde tendency
+   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: frq_rst_e3t                 ! restoring period for scale factors
+   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: frq_rst_hdv                 ! restoring period for low freq. divergence
+   REAL(wp)        , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: hsm, dsm                    ! 
+   INTEGER         , ALLOCATABLE, SAVE, DIMENSION(:,:)   :: i_int_bot
 
    !! * Substitutions
@@ -78,5 +95,5 @@
          ALLOCATE( tilde_e3t_b(jpi,jpj,jpk)  , tilde_e3t_n(jpi,jpj,jpk) , tilde_e3t_a(jpi,jpj,jpk) ,   &
             &      dtilde_e3t_a(jpi,jpj,jpk) , un_td  (jpi,jpj,jpk)     , vn_td  (jpi,jpj,jpk)     ,   &
-            &      STAT = dom_vvl_alloc        )
+            &      tildemask(jpi,jpj) , hsm(jpi,jpj) , dsm(jpi,jpj) , i_int_bot(jpi,jpj), STAT = dom_vvl_alloc )
          IF( lk_mpp             )   CALL mpp_sum ( dom_vvl_alloc )
          IF( dom_vvl_alloc /= 0 )   CALL ctl_warn('dom_vvl_alloc: failed to allocate arrays')
@@ -85,5 +102,6 @@
       ENDIF
       IF( ln_vvl_ztilde ) THEN
-         ALLOCATE( frq_rst_e3t(jpi,jpj) , frq_rst_hdv(jpi,jpj) , hdiv_lf(jpi,jpj,jpk) , STAT= dom_vvl_alloc )
+         ALLOCATE( frq_rst_e3t(jpi,jpj) , frq_rst_hdv(jpi,jpj) , hdivn_lf(jpi,jpj,jpk)             ,    &
+            &      un_lf(jpi,jpj,jpk), vn_lf(jpi,jpj,jpk)      , STAT= dom_vvl_alloc )
          IF( lk_mpp             )   CALL mpp_sum ( dom_vvl_alloc )
          IF( dom_vvl_alloc /= 0 )   CALL ctl_warn('dom_vvl_alloc: failed to allocate arrays')
@@ -117,5 +135,5 @@
       INTEGER ::   ji, jj, jk
       INTEGER ::   ii0, ii1, ij0, ij1
-      REAL(wp)::   zcoef
+      REAL(wp)::   zcoef, zwgt, ztmp, zhmin, zhmax
       !!----------------------------------------------------------------------
       !
@@ -129,5 +147,5 @@
       IF( dom_vvl_alloc() /= 0 )   CALL ctl_stop( 'STOP', 'dom_vvl_init : unable to allocate arrays' )
       !
-      !                    ! Read or initialize e3t_(b/n), tilde_e3t_(b/n) and hdiv_lf
+      !                    ! Read or initialize e3t_(b/n), tilde_e3t_(b/n) and hdivn_lf
       CALL dom_vvl_rst( nit000, 'READ' )
       e3t_a(:,:,jpk) = e3t_0(:,:,jpk)  ! last level always inside the sea floor set one for all
@@ -199,46 +217,71 @@
 
       !                    !==   z_tilde coordinate case  ==!   (Restoring frequencies)
+      tildemask(:,:) = 1._wp
+
       IF( ln_vvl_ztilde ) THEN
 !!gm : idea: add here a READ in a file of custumized restoring frequency
-         !                                   ! Values in days provided via the namelist
-         !                                   ! use rsmall to avoid possible division by zero errors with faulty settings
-         frq_rst_e3t(:,:) = 2._wp * rpi / ( MAX( rn_rst_e3t  , rsmall ) * 86400.0_wp )
-         frq_rst_hdv(:,:) = 2._wp * rpi / ( MAX( rn_lf_cutoff, rsmall ) * 86400.0_wp )
-         !
-         IF( ln_vvl_ztilde_as_zstar ) THEN   ! z-star emulation using z-tile
-            frq_rst_e3t(:,:) = 0._wp               !Ignore namelist settings
-            frq_rst_hdv(:,:) = 1._wp / rdt
+         ! Values in days provided via the namelist; use rsmall to avoid possible division by zero errors with faulty settings
+         frq_rst_e3t(:,:) = 2.0_wp * rpi / ( MAX( rn_rst_e3t  , rsmall ) * 86400.0_wp )
+         frq_rst_hdv(:,:) = 2.0_wp * rpi / ( MAX( rn_lf_cutoff, rsmall ) * 86400.0_wp )
+         !
+         IF( ln_vvl_ztilde_as_zstar ) THEN
+            ! Ignore namelist settings and use these next two to emulate z-star using z-tilde
+            frq_rst_e3t(:,:) = 0.0_wp 
+            frq_rst_hdv(:,:) = 1.0_wp / rdt
+            tildemask(:,:) = 0._wp
          ENDIF
-         IF ( ln_vvl_zstar_at_eqtor ) THEN   ! use z-star in vicinity of the Equator
+        
+         IF ( ln_vvl_zstar_at_eqtor ) THEN
             DO jj = 1, jpj
                DO ji = 1, jpi
-!!gm  case |gphi| >= 6 degrees is useless   initialized just above by default
+!!gm  case |gphi| >= 6 degrees is useless   initialized just above by default  
                   IF( ABS(gphit(ji,jj)) >= 6.) THEN
                      ! values outside the equatorial band and transition zone (ztilde)
                      frq_rst_e3t(ji,jj) =  2.0_wp * rpi / ( MAX( rn_rst_e3t  , rsmall ) * 86400.e0_wp )
-                     frq_rst_hdv(ji,jj) =  2.0_wp * rpi / ( MAX( rn_lf_cutoff, rsmall ) * 86400.e0_wp )
-                  ELSEIF( ABS(gphit(ji,jj)) <= 2.5) THEN    ! Equator strip ==> z-star
+!                     frq_rst_hdv(ji,jj) =  2.0_wp * rpi / ( MAX( rn_lf_cutoff, rsmall ) * 86400.e0_wp )
+              
+                  ELSEIF( ABS(gphit(ji,jj)) <= 2.5) THEN
                      ! values inside the equatorial band (ztilde as zstar)
                      frq_rst_e3t(ji,jj) =  0.0_wp
-                     frq_rst_hdv(ji,jj) =  1.0_wp / rdt
-                  ELSE                                      ! transition band (2.5 to 6 degrees N/S)
-                     !                                      ! (linearly transition from z-tilde to z-star)
+!                     frq_rst_hdv(ji,jj) =  1.0_wp / rdt
+                     tildemask(ji,jj) = 0._wp
+                  ELSE
+                     ! values in the transition band (linearly vary from ztilde to ztilde as zstar values)
                      frq_rst_e3t(ji,jj) = 0.0_wp + (frq_rst_e3t(ji,jj)-0.0_wp)*0.5_wp   &
                         &            * (  1.0_wp - COS( rad*(ABS(gphit(ji,jj))-2.5_wp)  &
                         &                                          * 180._wp / 3.5_wp ) )
-                     frq_rst_hdv(ji,jj) = (1.0_wp / rdt)                                &
-                        &            + (  frq_rst_hdv(ji,jj)-(1.e0_wp / rdt) )*0.5_wp   &
-                        &            * (  1._wp  - COS( rad*(ABS(gphit(ji,jj))-2.5_wp)  &
-                        &                                          * 180._wp / 3.5_wp ) )
+!                     frq_rst_hdv(ji,jj) = (1.0_wp / rdt)                                &
+!                        &            + (  frq_rst_hdv(ji,jj)-(1.e0_wp / rdt) )*0.5_wp   &
+!                        &            * (  1._wp  - COS( rad*(ABS(gphit(ji,jj))-2.5_wp)  &
+!                        &                                          * 180._wp / 3.5_wp ) )
+                     tildemask(ji,jj) = 0.5_wp * (  1._wp  - COS( rad*(ABS(gphit(ji,jj))-2.5_wp)  &
+                        &                                                 * 180._wp / 3.5_wp ) )
                   ENDIF
                END DO
             END DO
-            IF( cn_cfg == "orca" .AND. nn_cfg == 3 ) THEN   ! ORCA2: Suppress ztilde in the Foxe Basin for ORCA2
-               ii0 = 103   ;   ii1 = 111       
-               ij0 = 128   ;   ij1 = 135   ;   
-               frq_rst_e3t( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) =  0.0_wp
-               frq_rst_hdv( mi0(ii0):mi1(ii1) , mj0(ij0):mj1(ij1) ) =  1.e0_wp / rdt
-            ENDIF
          ENDIF
+         !
+         IF ( ln_vvl_zstar_on_shelf ) THEN
+            zhmin =  50._wp
+            zhmax = 100._wp
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  zwgt = 1._wp
+                  IF(( ht_0(ji,jj)>zhmin).AND.(ht_0(ji,jj) <=zhmax)) THEN
+                     zwgt = (ht_0(ji,jj)-zhmin)/(zhmax-zhmin)
+                  ELSEIF ( ht_0(ji,jj)<=zhmin) THEN
+                     zwgt = 0._wp
+                  ENDIF
+                  frq_rst_e3t(ji,jj) = MIN(frq_rst_e3t(ji,jj), frq_rst_e3t(ji,jj)*zwgt)
+                  tildemask(ji,jj)   = MIN(tildemask(ji,jj), zwgt)
+               END DO
+            END DO
+         ENDIF
+         !
+         ztmp = MAXVAL( frq_rst_hdv(:,:) )
+         IF( lk_mpp )   CALL mpp_max( ztmp )                 ! max over the global domain
+         !
+         IF ( (ztmp*rdt) > 1._wp) CALL ctl_stop( 'dom_vvl_init: rn_lf_cuttoff is too small' )
+         !
       ENDIF
       !
@@ -256,5 +299,7 @@
          IF( ln_vvl_ztilde ) THEN                    ! z_tilde case !
             !                                        ! ------------ !
-            CALL iom_set_rstw_var_active('hdiv_lf')
+            CALL iom_set_rstw_var_active('un_lf')
+            CALL iom_set_rstw_var_active('vn_lf')
+            CALL iom_set_rstw_var_active('hdivn_lf')
          ENDIF
          !
@@ -279,5 +324,5 @@
       !!                               to the "baroclinic" level thickness.
       !!
-      !! ** Action  :  - hdiv_lf    : restoring towards full baroclinic divergence in z_tilde case
+      !! ** Action  :  - hdivn_lf   : restoring towards full baroclinic divergence in z_tilde case
       !!               - tilde_e3t_a: after increment of vertical scale factor 
       !!                              in z_tilde case
@@ -289,10 +334,15 @@
       INTEGER, INTENT( in ), OPTIONAL ::   kcall   ! optional argument indicating call sequence
       !
+      LOGICAL                ::   ll_do_bclinic         ! local logical
       INTEGER                ::   ji, jj, jk            ! dummy loop indices
+      INTEGER                ::   ib, ib_bdy, ip, jp    !   "     "     "
       INTEGER , DIMENSION(3) ::   ijk_max, ijk_min      ! temporary integers
-      REAL(wp)               ::   z2dt, z_tmin, z_tmax  ! local scalars
-      LOGICAL                ::   ll_do_bclinic         ! local logical
+      INTEGER                ::   ncall
+      REAL(wp)               ::   z2dt  , z_tmin, z_tmax! local scalars                
+      REAL(wp)               ::   zalpha, zwgt          ! temporary scalars
+      REAL(wp)               ::   zdu, zdv, zramp
+      REAL(wp)               ::   ztra, zbtr, ztout, ztin, zfac, zmsku, zmskv
       REAL(wp), DIMENSION(jpi,jpj)     ::   zht, z_scale, zwu, zwv, zhdiv
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ze3t
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ze3t, ztu, ztv
       !!----------------------------------------------------------------------
       !
@@ -308,10 +358,21 @@
 
       ll_do_bclinic = .TRUE.
+      ncall = 1
+
       IF( PRESENT(kcall) ) THEN
-         IF( kcall == 2 .AND. ln_vvl_ztilde )   ll_do_bclinic = .FALSE.
+         ! comment line below if tilda coordinate has to be computed at each call
+         ! This is not working yet
+!         IF (kcall == 2 .AND. (ln_vvl_ztilde.OR.ln_vvl_layer) ) ll_do_bclinic = .FALSE.
+         ncall = kcall  
+      ENDIF
+
+      IF( neuler == 0 .AND. kt == nit000 ) THEN
+         z2dt =  rdt
+      ELSE
+         z2dt = 2.0_wp * rdt
       ENDIF
 
       ! ******************************* !
-      ! After acale factors at t-points !
+      ! After scale factors at t-points !
       ! ******************************* !
       !                                                ! --------------------------------------------- !
